Package wx :: Class UpdateUIEvent

[frames | no frames]

## Type UpdateUIEvent

    object --+
             |
        Object --+
                 |
             Event --+
                     |
          CommandEvent --+
                         |
                        UpdateUIEvent

This class is used for EVT_UPDATE_UI pseudo-events which are sent by wxWidgets to give an application the chance to update various user interface elements.

Without update UI events, an application has to work hard to check/uncheck, enable/disable, and set the text for elements such as menu items and toolbar buttons. The code for doing this has to be mixed up with the code that is invoked when an action is invoked for a menu item or button.

With update UI events, you define an event handler to look at the state of the application and change UI elements accordingly. wxWidgets will call your handler functions in idle time, so you don't have to worry where to call this code. In addition to being a clearer and more declarative method, it also means you don't have to worry whether you're updating a toolbar or menubar identifier. The same handler can update a menu item and toolbar button, if the ID values are the same.

Instead of directly manipulating the menu or button, you call functions in the event object, such as `Check`. wxWidgets will determine whether such a call has been made, and which UI element to update.

These events will work for popup menus as well as menubars. Just before a menu is popped up, `wx.Menu.UpdateUI` is called to process any UI events for the window that owns the menu.

If you find that the overhead of UI update processing is affecting your application, you can do one or both of the following:

> 1. Call `wx.UpdateUIEvent.SetMode` with a value of wx.UPDATE_UI_PROCESS_SPECIFIED, and set the extra style wx.WS_EX_PROCESS_UPDATE_EVENTS for every window that should receive update events. No other windows will receive update events.
> 2. Call `wx.UpdateUIEvent.SetUpdateInterval` with a millisecond value to set the delay between updates. You may need to call `wx.Window.UpdateWindowUI` at critical points, for example when a dialog is about to be shown, in case the user sees a slight delay before windows are updated.

Note that although events are sent in idle time, defining a EVT_IDLE handler for a window does not affect this because the events are sent from an internal idle handler.

wxWidgets tries to optimize update events on some platforms. On Windows and GTK+, events for menubar items are only sent when the menu is about to be shown, and not in idle time.

Method Summary
UpdateUIEvent | ``__init__`(self, commandId)` Constructor
bool | ``CanUpdate`(win)` Returns `True` if it is appropriate to update (send UI update events to) this window. (Static method)
| ``Check`(self, check)` Check or uncheck the UI element.
| ``Enable`(self, enable)` Enable or disable the UI element.
bool | ``GetChecked`(self)` Returns `True` if the UI element should be checked.
bool | ``GetEnabled`(self)` Returns `True` if the UI element should be enabled.
int | ``GetMode`()` Returns a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events. (Static method)
bool | ``GetSetChecked`(self)` Returns `True` if the application has called `Check`.
bool | ``GetSetEnabled`(self)` Returns `True` if the application has called `Enable`.
bool | ``GetSetShown`(self)` Returns `True` if the application has called `Show`.
bool | ``GetSetText`(self)` Returns `True` if the application has called `SetText`.
bool | ``GetShown`(self)` Returns `True` if the UI element should be shown.
String | ``GetText`(self)` Returns the text that should be set for the UI element.
long | ``GetUpdateInterval`()` Returns the current interval between updates in milliseconds. (Static method)
| ``ResetUpdateTime`()` Used internally to reset the last-updated time to the current time. (Static method)
| ``SetMode`(mode)` Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events. (Static method)
| ``SetText`(self, text)` Sets the text for this UI element.
| ``SetUpdateInterval`(updateInterval)` Sets the interval between updates in milliseconds. (Static method)
| ``Show`(self, show)` Show or hide the UI element.

Property Summary
| `Checked`: See `GetChecked`
| `Enabled`: See `GetEnabled`
| `Shown`: See `GetShown`
| `Text`: See `GetText` and `SetText`
| `thisown`: The membership flag

Instance Method Details

### __init__(self, commandId=0)
(Constructor)

Constructor

  Parameters:
    `commandId`
    (type=int)

  Returns:
    UpdateUIEvent
  Overrides:
    `wx.CommandEvent.__init__`

### Check(self, check)

Check or uncheck the UI element.

  Parameters:
    `check`
    (type=bool)

### Enable(self, enable)

Enable or disable the UI element.

  Parameters:
    `enable`
    (type=bool)

### GetChecked(self)

Returns `True` if the UI element should be checked.

  Returns:
    bool

### GetEnabled(self)

Returns `True` if the UI element should be enabled.

  Returns:
    bool

### GetSetChecked(self)

Returns `True` if the application has called `Check`. For wxWidgets internal use only.

  Returns:
    bool

### GetSetEnabled(self)

Returns `True` if the application has called `Enable`. For wxWidgets internal use only.

  Returns:
    bool

### GetSetShown(self)

Returns `True` if the application has called `Show`. For wxWidgets internal use only.

  Returns:
    bool

### GetSetText(self)

Returns `True` if the application has called `SetText`. For wxWidgets internal use only.

  Returns:
    bool

### GetShown(self)

Returns `True` if the UI element should be shown.

  Returns:
    bool

### GetText(self)

Returns the text that should be set for the UI element.

  Returns:
    String

### SetText(self, text)

Sets the text for this UI element.

  Parameters:
    `text`
    (type=String)

### Show(self, show)

Show or hide the UI element.

  Parameters:
    `show`
    (type=bool)

Static Method Details

### CanUpdate(win)

Returns `True` if it is appropriate to update (send UI update events to) this window.

This function looks at the mode used (see `wx.UpdateUIEvent.SetMode`), the wx.WS_EX_PROCESS_UPDATE_EVENTS flag in window, the time update events were last sent in idle time, and the update interval, to determine whether events should be sent to this window now. By default this will always return true because the update mode is initially wx.UPDATE_UI_PROCESS_ALL and the interval is set to 0; so update events will be sent as often as possible. You can reduce the frequency that events are sent by changing the mode and/or setting an update interval.

  Parameters:
    `win`
    (type=Window)

  Returns:
    bool

### GetMode()

Returns a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

  Returns:
    int

### GetUpdateInterval()

Returns the current interval between updates in milliseconds. -1 disables updates, 0 updates as frequently as possible.

  Returns:
    long

### ResetUpdateTime()

Used internally to reset the last-updated time to the current time. It is assumed that update events are normally sent in idle time, so this is called at the end of idle processing.

### SetMode(mode)

Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

The mode may be one of the following values:

> wxUPDATE_UI_PROCESS_ALL | Send UI update events to all windows. This is the default setting.
> wxUPDATE_UI_PROCESS_SPECIFIED | Send UI update events only to windows that have the wx.WS_EX_PROCESS_UI_UPDATES extra style set.

  Parameters:
    `mode`
    (type=int)

### SetUpdateInterval(updateInterval)

Sets the interval between updates in milliseconds. Set to -1 to disable updates, or to 0 to update as frequently as possible. The default is 0.

Use this to reduce the overhead of UI update events if your application has a lot of windows. If you set the value to -1 or greater than 0, you may also need to call `wx.Window.UpdateWindowUI` at appropriate points in your application, such as when a dialog is about to be shown.

  Parameters:
    `updateInterval`
    (type=long)

Property Details

### Checked

See `GetChecked`

  Get Method:
    `GetChecked`(self)
  Set Method:
    `Check`(self, check)

### Enabled

See `GetEnabled`

  Get Method:
    `GetEnabled`(self)
  Set Method:
    `Enable`(self, enable)

### Shown

See `GetShown`

  Get Method:
    `GetShown`(self)
  Set Method:
    `Show`(self, show)

### Text

See `GetText` and `SetText`

  Get Method:
    `GetText`(self)
  Set Method:
    `SetText`(self, text)

### thisown

The membership flag

Generated by Epydoc 2.1.20050511.rpd on Thu Mar 22 12:08:39 2007 | http://epydoc.sf.net